' "MAP.BAS" is a graphic routine to plot the satellite data that resides
'           within the data file "WORLD.DAT".
' This program plots geographic data from the file containing
' continents and coordinate grids on the MERCATOR, EQUIDISTANT
' CYLINDRICAL, SINUSOIDAL, HAMMER, and ORTHOGRAPHIC map
' projections.
'
' Created by Robert V. Kaufman, Sept-1988.
' Copyright 1988 by Robert V. Kaufman.
   DECLARE SUB Center (row!, text$)
   DECLARE SUB IntroPause ()
   SCREEN 0, 0, 0, 0
   CALL IntroPause
   PI = 3.1415926535898#
   TWOPI = 2 * PI
   SQRT2 = SQR(2)
60 KEY OFF: CLS
   PRINT
   PRINT "Do you want geopolitical boundaries";
   INPUT ANSWER$
   ANSWER$ = UCASE$(LEFT$(ANSWER$, 1))
   NUMBER.OF.RECORDS = 7561: IF ANSWER$ = "Y" THEN NUMBER.OF.RECORDS = NUMBER.OF.RECORDS + 29603

70 PRINT
   PRINT "MAP TYPE"
   PRINT "   1   Mercator"
   PRINT "   2   Equidistant"
   PRINT "   3   Sinusoidal"
   PRINT "   4   Hammer"
   PRINT "   5   Orthographic"
   PRINT : PRINT "Enter the MAPTYPE";
   INPUT MAPTYPE
   PRINT
   PRINT "Central longitude of Map (default=0)";
   INPUT LAMBDA0
   IF MAPTYPE = 2 OR MAPTYPE = 5 THEN
     PRINT "Central Latitude of Map (default=0)";
     INPUT PHI1
   END IF
   IF MAPTYPE >= 4 THEN
     r = 83
   ELSE
     r = 70
   END IF
30  PRINT
   PRINT "Plot Grid, Continents, or Both (G/C/B)";
   INPUT ANSWER$
   ANSWER$ = UCASE$(ANSWER$)
   IF ANSWER$ = "G" THEN 40
   IF ANSWER$ = "C" THEN 40
   IF ANSWER$ = "B" THEN 40
   GOTO 30

40 SCREEN 9
   COLOR 3, 0: CLS
   grid$ = ANSWER$
   IF MAPTYPE = 1 THEN
     maxlat = 80
     GOTO 1000
   END IF
   IF MAPTYPE = 2 THEN
     maxlat = 90
     GOTO 2000
   END IF
   IF MAPTYPE = 3 THEN
     maxlat = 90
     GOTO 3000
   END IF
   IF MAPTYPE = 4 THEN
     maxlat = 90
     GOTO 4000
   END IF
   IF MAPTYPE = 5 THEN
     GOTO 5000
   END IF
1000 'Grid Mercator
      LINE (20, 20)-(20, 330)
      LINE (20, 330)-(620, 330)
      LINE (620, 330)-(620, 20)
      LINE (620, 20)-(20, 20)
      X1 = -180: X2 = 180
      PHI = SIN(maxlat * PI / 180)
      t = ABS(PHI)
      IF t < 1 THEN a = .5 * LOG((1 + t) / (1 - t)): IF PHI < 0 THEN a = -a
      Y2 = a
      PHI = SIN(-maxlat * PI / 180)
      t = ABS(PHI)
      IF t < 1 THEN a = .5 * LOG((1 + t) / (1 - t)): IF PHI < 0 THEN a = -a
      Y1 = a
      IF ANSWER$ = "C" THEN 6000
      FOR LONGITUDE = -80 TO 80 STEP 20
        PHI = SIN(LONGITUDE * PI / 180)
        t = ABS(PHI)
        IF t < 1 THEN a = .5 * LOG((1 + t) / (1 - t)): IF PHI < 0 THEN a = -a
        LONGI = a
        X0 = (620 - 20) / (X2 - X1) * (-180 - X1) + 20
        X = (620 - 20) / (X2 - X1) * (180 - X1) + 20
        Y = ((20 - 330) / (Y2 - Y1) * (LONGI - Y1) + 330)
        IF Y < 20 THEN Y = 20
        IF Y > 330 THEN Y = 330
        LINE (X0, Y)-(X, Y)
      NEXT LONGITUDE
      FOR LATITUDE = -180 TO 180.01 STEP 60
        LATI = LATITUDE - LAMBDA0
        IF LATI > 180 THEN LATI = LATI - 360
        IF LATI < -180 THEN LATI = LATI + 360
        X = (620 - 20) / (X2 - X1) * (LATI - X1) + 20
        LINE (X, 20)-(X, 330)
      NEXT LATITUDE: GOTO 6000

2000 'Grid Equidistant
      LINE (20, 20)-(20, 330)
      LINE (20, 330)-(620, 330)
      LINE (620, 330)-(620, 20)
      LINE (620, 20)-(20, 20)
      X1 = -180: X2 = 180
      Y1 = -90 * ABS(COS(PHI1 * PI / 180))
      Y2 = 90 * ABS(COS(PHI1 * PI / 180))
      IF ANSWER$ = "C" THEN 6000
      FOR LONGITUDE = -90 TO 90.01 STEP 30
        LONGI = LONGITUDE * COS(PHI1)
        IF LONGI > 90 THEN LONGI = LONGI - 180
        IF LONGI < -90 THEN LONGI = LONGI + 180
        X0 = (620 - 20) / (X2 - X1) * (-180 - X1) + 20
        X = (620 - 20) / (X2 - X1) * (180 - X1) + 20
        Y = ((20 - 330) / (Y2 - Y1) * (LONGI - Y1) + 330)
        IF Y < 20 THEN Y = 20
        IF Y > 330 THEN Y = 330
        LINE (X0, Y)-(X, Y)
      NEXT LONGITUDE
      FOR LATITUDE = -180 TO 180.01 STEP 60
        LATI = LATITUDE - LAMBDA0
        IF LATI > 180 THEN LATI = LATI - 360
        IF LATI < -180 THEN LATI = LATI + 360
        X = (620 - 20) / (X2 - X1) * (LATI - X1) + 20
        LINE (X, 20)-(X, 330)
      NEXT LATITUDE: GOTO 6000

3000 'Grid Sinusodial
     X1 = -180: X2 = 180: Y1 = -90: Y2 = 90
     FLAG = 0
     FOR LATITUDE = Y1 TO Y2 STEP 5
       LONGI = -180 * COS(LATITUDE * PI / 180)
       LATI = LATITUDE
       X = (620 - 20) / (X2 - X1) * (LONGI - X1) + 20
       Y = (20 - 330) / (Y2 - Y1) * (LATI - Y1) + 330
       IF FLAG = 0 THEN
         PSET (X, Y)
       ELSE
         LINE (X0, Y0)-(X, Y)
       END IF
       X0 = X: Y0 = Y
       IF FLAG = 0 THEN FLAG = 1
     NEXT LATITUDE
     FLAG = 0
     FOR LATITUDE = Y1 TO Y2 STEP 5
       LONGI = 180 * COS(LATITUDE * PI / 180)
       LATI = LATITUDE
       X = (620 - 20) / (X2 - X1) * (LONGI - X1) + 20
       Y = (20 - 330) / (Y2 - Y1) * (LATI - Y1) + 330
       IF FLAG = 0 THEN
         PSET (X, Y)
       ELSE
         LINE (X0, Y0)-(X, Y)
       END IF
       X0 = X: Y0 = Y
       IF FLAG = 0 THEN FLAG = 1
     NEXT LATITUDE
     IF ANSWER$ = "C" THEN 6000
     FOR LONGITUDE = X1 TO X2 + .01 STEP 60
      LONGIT = LONGITUDE - LAMBDA0
      IF LONGIT > 180 THEN LONGIT = LONGIT - 360
      IF LONGIT < -180 THEN LONGIT = LONGIT + 360
      FLAG = 0
      FOR LATITUDE = Y1 TO Y2 + .05 STEP 5
        LONGI = LONGIT * COS(LATITUDE * PI / 180)
        LATI = LATITUDE
        X = (620 - 20) / (X2 - X1) * (LONGI - X1) + 20
        Y = (20 - 330) / (Y2 - Y1) * (LATI - Y1) + 330
        IF FLAG = 0 THEN
          PSET (X, Y)
        ELSE
          LINE (X0, Y0)-(X, Y)
        END IF
        X0 = X: Y0 = Y
        IF FLAG = 0 THEN FLAG = 1
      NEXT LATITUDE
    NEXT LONGITUDE
    FOR LATITUDE = Y1 TO Y2 + .01 STEP 30
      FLAG = 0
      FOR LONGITUDE = X1 TO X2 + .01 STEP 60
        LONGI = LONGITUDE * COS(LATITUDE * PI / 180)
        LATI = LATITUDE
        X = (620 - 20) / (X2 - X1) * (LONGI - X1) + 20
        Y = (20 - 330) / (Y2 - Y1) * (LATI - Y1) + 330
        IF FLAG = 0 THEN
          PSET (X, Y)
        ELSE
          LINE (X0, Y0)-(X, Y)
        END IF
        X0 = X: Y0 = Y
        IF FLAG = 0 THEN FLAG = 1
      NEXT LONGITUDE
    NEXT LATITUDE: GOTO 6000

4000 'Grid Hammer
     X1 = -2 * SQRT2: X2 = 2 * SQRT2
     Y1 = -SQRT2: Y2 = SQRT2
     FLAG = 0
     FOR LATITUDE = -90 TO 90.01 STEP 5
       LONGI = 180
       HALFLAMBDA = .5 * LONGI
       COSPHI = COS(LATITUDE * PI / 180)
       K = SQRT2 / SQR(1 + COSPHI * COS(HALFLAMBDA * PI / 180))
       LONGI = 2 * K * COSPHI * SIN(HALFLAMBDA * PI / 180)
       LATI = K * SIN(LATITUDE * PI / 180)
       X = (620 - 20) / (X2 - X1) * (LONGI - X1) + 20
       Y = (20 - 330) / (Y2 - Y1) * (LATI - Y1) + 330
       IF FLAG = 0 THEN
         PSET (X, Y)
       ELSE
         LINE (X0, Y0)-(X, Y)
       END IF
       X0 = X: Y0 = Y
       IF FLAG = 0 THEN FLAG = 1
     NEXT LATITUDE
     FLAG = 0
     FOR LATITUDE = -90 TO 90.01 STEP 5
       LONGI = -180
       HALFLAMBDA = .5 * LONGI
       COSPHI = COS(LATITUDE * PI / 180)
       K = SQRT2 / SQR(1 + COSPHI * COS(HALFLAMBDA * PI / 180))
       LONGI = 2 * K * COSPHI * SIN(HALFLAMBDA * PI / 180)
       LATI = K * SIN(LATITUDE * PI / 180)
       X = (620 - 20) / (X2 - X1) * (LONGI - X1) + 20
       Y = (20 - 330) / (Y2 - Y1) * (LATI - Y1) + 330
       IF FLAG = 0 THEN
         PSET (X, Y)
       ELSE
         LINE (X0, Y0)-(X, Y)
       END IF
       X0 = X: Y0 = Y
       IF FLAG = 0 THEN FLAG = 1
     NEXT LATITUDE
     IF ANSWER$ = "C" THEN 6000
     FOR LONGITUDE = -180 TO 180.01 STEP 60
       FLAG = 0
       FOR LATITUDE = -90 TO 90.01 STEP 5
         LONGI = LONGITUDE
         DELLAM = LONGI - LAMBDA0
         IF DELLAM < -180 THEN DELLAM = DELLAM + 360
         IF DELLAM > 180 THEN DELLAM = DELLAM - 360
         HALFLAMBDA = DELLAM / 2
         COSPHI = COS(LATITUDE * PI / 180)
         K = SQRT2 / SQR(1 + COSPHI * COS(HALFLAMBDA * PI / 180))
         LONGI = 2 * K * COSPHI * SIN(HALFLAMBDA * PI / 180)
         LATI = K * SIN(LATITUDE * PI / 180)
         X = (620 - 20) / (X2 - X1) * (LONGI - X1) + 20
         Y = (20 - 330) / (Y2 - Y1) * (LATI - Y1) + 330
         IF FLAG = 0 THEN
           PSET (X, Y)
         ELSE
           LINE (X0, Y0)-(X, Y)
         END IF
         X0 = X: Y0 = Y
         IF FLAG = 0 THEN FLAG = 1
       NEXT LATITUDE
     NEXT LONGITUDE
     FOR LATITUDE = -90 TO 90.01 STEP 30
       FLAG = 0
       FOR LONGITUDE = -180 TO 180.01 STEP 5
         LONGI = LONGITUDE
         DELLAM = LONGI
         IF DELLAM < -180 THEN DELLAM = DELLAM + 360
         IF DELLAM > 180 THEN DELLAM = DELLAM - 360
         HALFLAMBDA = DELLAM / 2
         COSPHI = COS(LATITUDE * PI / 180)
         K = SQRT2 / SQR(1 + COSPHI * COS(HALFLAMBDA * PI / 180))
         LONGI = 2 * K * COSPHI * SIN(HALFLAMBDA * PI / 180)
         LATI = K * SIN(LATITUDE * PI / 180)
         X = (620 - 20) / (X2 - X1) * (LONGI - X1) + 20
         Y = (20 - 330) / (Y2 - Y1) * (LATI - Y1) + 330
         IF FLAG = 0 THEN
           PSET (X, Y)
         ELSE
           LINE (X0, Y0)-(X, Y)
         END IF
         X0 = X: Y0 = Y
         IF FLAG = 0 THEN FLAG = 1
       NEXT LONGITUDE
     NEXT LATITUDE
     GOTO 6000

5000 'Grid Orthographic
     X1 = -2: X2 = 2: Y1 = -2: Y2 = 2
     RADIUS = 2
     FLAG = 0
     FOR iANGLE = 0 TO 360 STEP 10
       X = COS(iANGLE * PI / 180) * RADIUS
       Y = SIN(iANGLE * PI / 180) * RADIUS
       X = (620 - 20) / (X2 - X1) * (X - X1) + 20
       Y = (20 - 330) / (Y2 - Y1) * (Y - Y1) + 330
       IF FLAG = 0 THEN
         PSET (X, Y)
       ELSE
         LINE (X0, Y0)-(X, Y)
       END IF
       X0 = X: Y0 = Y: FLAG = 1
     NEXT iANGLE
     IF ANSWER$ = "C" THEN 6000
     FOR LONGITUDE = -180 TO 180.01 STEP 30
      FLAG = 0
      FOR LATITUDE = -90 TO 90.01 STEP 5
        Lambda = LONGITUDE - LAMBDA0
        r2 = 2
        cosphi1 = COS(PHI1 * PI / 180): sinphi1 = SIN(PHI1 * PI / 180)
        COSPHI = COS(LATITUDE * PI / 180): sinphi = SIN(LATITUDE * PI / 180)
        cosL = COS(Lambda * PI / 180) * COSPHI
        COSc = sinphi1 * sinphi + cosphi1 * cosL
        visible = 0: 'Not visible
        IF COSc >= 0 THEN
          X = r2 * COSPHI * SIN(Lambda * PI / 180)
          Y = r2 * (cosphi1 * sinphi - sinphi1 * cosL)
          visible = 1
        END IF
        IF visible = 0 THEN FLAG = 0: GOTO 5010
        X = (620 - 20) / (X2 - X1) * (X - X1) + 20
        Y = (20 - 330) / (Y2 - Y1) * (Y - Y1) + 330
        IF FLAG = 0 THEN PSET (X, Y) ELSE LINE (X0, Y0)-(X, Y)
        FLAG = 1: X0 = X: Y0 = Y
5010  NEXT LATITUDE
    NEXT LONGITUDE
    FOR LATITUDE = -90 TO 90.01 STEP 30
      FLAG = 0
      FOR LONGITUDE = -180 TO 180.01 STEP 5
        Lambda = LONGITUDE - LAMBDA0
        r2 = 2
        cosphi1 = COS(PHI1 * PI / 180): sinphi1 = SIN(PHI1 * PI / 180)
        COSPHI = COS(LATITUDE * PI / 180): sinphi = SIN(LATITUDE * PI / 180)
        cosL = COS(Lambda * PI / 180) * COSPHI
        COSc = sinphi1 * sinphi + cosphi1 * cosL
        visible = 0: 'Not visible
        IF COSc >= 0 THEN
          X = r2 * COSPHI * SIN(Lambda * PI / 180)
          Y = r2 * (cosphi1 * sinphi - sinphi1 * cosL)
          visible = 1
        END IF
        IF visible = 0 THEN FLAG = 0: GOTO 5020
        X = (620 - 20) / (X2 - X1) * (X - X1) + 20
        Y = (20 - 330) / (Y2 - Y1) * (Y - Y1) + 330
        IF FLAG = 0 THEN PSET (X, Y) ELSE LINE (X0, Y0)-(X, Y)
        FLAG = 1: X0 = X: Y0 = Y
5020  NEXT LONGITUDE
    NEXT LATITUDE: GOTO 6000

6000 IF grid$ = "G" THEN 9999
     COLOR 10, 0
     IF MAPTYPE = 1 THEN 6100
     IF MAPTYPE = 2 THEN 6200
     IF MAPTYPE = 3 THEN 6300
     IF MAPTYPE = 4 THEN 6400
     IF MAPTYPE = 5 THEN 6500
     GOTO 9999
6100 'Draw continents of Meractor
     FLAG = 0: X1 = -180: X2 = 180
     PHI = SIN(maxlat * PI / 180)
     t = ABS(PHI)
     IF t < 1 THEN a = .5 * LOG((1 + t) / (1 - t)): IF PHI < 0 THEN a = -a
     Y2 = a
     PHI = SIN(-maxlat * PI / 180)
     t = ABS(PHI)
     IF t < 1 THEN a = .5 * LOG((1 + t) / (1 - t)): IF PHI < 0 THEN a = -a
     Y1 = a
     OPEN "I", 7, "WORLD.DAT"
     FOR I = 1 TO NUMBER.OF.RECORDS
       INPUT #7, LABEL$, LONGI, LATI
       IF LEFT$(LABEL$, 1) = "L" THEN FLAG = 0
       LATITUDE = LATI / 100: LONGITUDE = LONGI / 100
       LONGITUDE = LONGITUDE - LAMBDA0
       IF LONGITUDE > 180 THEN LONGITUDE = LONGITUDE - 360
       IF LONGITUDE < -180 THEN LONGITUDE = LONGITUDE + 360
       XLOOP = LONGITUDE
       PHI = SIN(LATITUDE * PI / 180)
       t = ABS(PHI)
       IF t < 1 THEN a = .5 * LOG((1 + t) / (1 - t)): IF PHI < 0 THEN a = -a
       yloop = a
       X = (620 - 20) / (X2 - X1) * (XLOOP - X1) + 20
       Y = (20 - 330) / (Y2 - Y1) * (yloop - Y1) + 330
       IF ABS(X0 - X) > 100 THEN FLAG = 0
       IF X < 20 OR Y < 20 OR Y > 330 OR X > 620 THEN FLAG = 0: GOTO 6110
       IF FLAG < 1 THEN
         LINE (X, Y)-(X, Y)
         FLAG = 1: X0 = X: Y0 = Y
         GOTO 6110
       END IF
       LINE (X0, Y0)-(X, Y)
       X0 = X: Y0 = Y
6110 NEXT I
     CLOSE #7
     GOTO 9999

6200 'Draw continents of Equidistant
     X1 = -180: X2 = 180
     Y1 = -90 * ABS(COS(PHI1 * PI / 180))
     Y2 = 90 * ABS(COS(PHI1 * PI / 180))
     OPEN "I", 7, "WORLD.DAT"
     FOR I = 1 TO NUMBER.OF.RECORDS
       INPUT #7, LABEL$, LONGI, LATI
       IF LEFT$(LABEL$, 1) = "L" THEN FLAG = 0
       LATITUDE = LATI / 100: LONGITUDE = LONGI / 100
       LONGITUDE = LONGITUDE - LAMBDA0
       LATITUDE = LATITUDE * COS(PHI1)
       IF LONGITUDE > 180 THEN LONGITUDE = LONGITUDE - 360
       IF LONGITUDE < -180 THEN LONGITUDE = LONGITUDE + 360
       IF LATITUDE > 90 THEN LATITUDE = LATITUDE - 180
       IF LATITUDE < -90 THEN LATITUDE = LATITUDE + 180
       X = (620 - 20) / (X2 - X1) * (LONGITUDE - X1) + 20
       Y = ((20 - 330) / (Y2 - Y1) * (LATITUDE - Y1) + 330)
       IF ABS(X0 - X) > 100 THEN FLAG = 0
       IF ABS(Y0 - Y) > 100 THEN FLAG = 0
       IF X < 20 OR Y < 20 OR Y > 330 OR X > 620 THEN FLAG = 0: GOTO 6210
       IF FLAG < 1 THEN LINE (X, Y)-(X, Y): FLAG = 1: X0 = X: Y0 = Y: GOTO 6210
       LINE (X0, Y0)-(X, Y): X0 = X: Y0 = Y
6210 NEXT I
     CLOSE #7
     GOTO 9999

6300 'Draw continents of Sinusoidal
     FLAG = 0: X1 = -180: X2 = 180
     OPEN "I", 7, "WORLD.DAT"
     FOR I = 1 TO NUMBER.OF.RECORDS
       INPUT #7, LABEL$, LONGI, LATI
       IF LEFT$(LABEL$, 1) = "L" THEN FLAG = 0
       LATITUDE = LATI / 100: LONGITUDE = LONGI / 100
       LONGITUDE = LONGITUDE - LAMBDA0
       IF LONGITUDE > 180 THEN LONGITUDE = LONGITUDE - 360
       IF LONGITUDE < -180 THEN LONGITUDE = LONGITUDE + 360
       XLOOP = LONGITUDE * COS(LATITUDE * PI / 180)
       yloop = LATITUDE
       X = (620 - 20) / (X2 - X1) * (XLOOP - X1) + 20
       Y = (20 - 330) / (Y2 - Y1) * (yloop - Y1) + 330
       IF ABS(X0 - X) > 50 THEN FLAG = 0
       IF X < 20 OR Y < 20 OR Y > 330 OR X > 620 THEN FLAG = 0: GOTO 6310
       IF FLAG = 0 THEN
          PSET (X, Y)
        ELSE
          LINE (X0, Y0)-(X, Y)
        END IF
        FLAG = 1: X0 = X: Y0 = Y
6310 NEXT I
     CLOSE #7
     GOTO 9999
    
6400 'Draw the map of the HAMMER projection
     X1 = -2 * SQRT2: X2 = 2 * SQRT2
     Y1 = -SQRT2: Y2 = SQRT2
     FLAG = 0
     OPEN "I", 7, "WORLD.DAT"
     FOR I = 1 TO NUMBER.OF.RECORDS
       INPUT #7, LABEL$, LONGI, LATI
       IF LEFT$(LABEL$, 1) = "L" THEN FLAG = 0
       LATITUDE = LATI / 100: LONGITUDE = LONGI / 100
       LONGI = LONGITUDE
       DELLAM = LONGI - LAMBDA0
       IF DELLAM < -180 THEN DELLAM = DELLAM + 360
       IF DELLAM > 180 THEN DELLAM = DELLAM - 360
       HALFLAMBDA = DELLAM / 2
       COSPHI = COS(LATITUDE * PI / 180)
       K = SQRT2 / SQR(1 + COSPHI * COS(HALFLAMBDA * PI / 180))
       LONGI = 2 * K * COSPHI * SIN(HALFLAMBDA * PI / 180)
       LATI = K * SIN(LATITUDE * PI / 180)
       X = (620 - 20) / (X2 - X1) * (LONGI - X1) + 20
       Y = (20 - 330) / (Y2 - Y1) * (LATI - Y1) + 330
       IF ABS(X0 - X) > 100 OR ABS(Y0 - Y) > 100 THEN FLAG = 0
       IF FLAG = 0 THEN
         PSET (X, Y)
       ELSE
         LINE (X0, Y0)-(X, Y)
       END IF
       X0 = X: Y0 = Y
       IF FLAG = 0 THEN FLAG = 1
6410 NEXT I
     CLOSE #7
     GOTO 9999

6500 'Draw the map of ORTHOGRAPHIC projection
     FLAG = 0
     OPEN "I", 7, "WORLD.DAT"
     FOR I = 1 TO NUMBER.OF.RECORDS
       INPUT #7, LABEL$, LONGI, LATI
       IF LEFT$(LABEL$, 1) = "L" THEN FLAG = 0
       LATITUDE = LATI / 100: LONGITUDE = LONGI / 100
       Lambda = LONGITUDE - LAMBDA0
       r2 = 2
       cosphi1 = COS(PHI1 * PI / 180): sinphi1 = SIN(PHI1 * PI / 180)
       COSPHI = COS(LATITUDE * PI / 180): sinphi = SIN(LATITUDE * PI / 180)
       cosL = COS(Lambda * PI / 180) * COSPHI
       COSc = sinphi1 * sinphi + cosphi1 * cosL
       visible = 0: 'Not visible
       IF COSc >= 0 THEN
         X = r2 * COSPHI * SIN(Lambda * PI / 180)
         Y = r2 * (cosphi1 * sinphi - sinphi1 * cosL)
         visible = 1
       END IF
       IF visible = 0 THEN FLAG = 0: GOTO 6510
       X = (620 - 20) / (X2 - X1) * (X - X1) + 20
       Y = (20 - 330) / (Y2 - Y1) * (Y - Y1) + 330
       IF FLAG = 0 THEN
         PSET (X, Y)
       ELSE
         LINE (X0, Y0)-(X, Y)
       END IF
       FLAG = 1: X0 = X: Y0 = Y
6510 NEXT I
     CLOSE #7
     GOTO 9999


9999 LOCATE 25, 40 - LEN("Press <Q> to quit") / 2
     PRINT "Press <Q> to quit";
     MESSAGE$ = INKEY$: IF UCASE$(MESSAGE$) <> "Q" THEN 9999
     SYSTEM: END

'Center:
'  Centers text on given row
SUB Center (row, text$)
    LOCATE row, 41 - LEN(text$) / 2
    PRINT text$;
END SUB

'IntroPause:
'  Creates flashing border for intro screen
SUB IntroPause
  CLS
  COLOR 9, 0
  Center 4, "M   A   P"
  COLOR 10, 0
  Center 6, "This program plots geographic data from the file containing "
  Center 7, "continents and coordinate grids on the MERCATOR, EQUIDISTANT"
  Center 8, "CYLINDRICAL, SINUSOIDAL, HAMMER, and ORTHOGRAPHIC map       "
  Center 9, "projections.                                                "
  Center 17, "Copyright 1993 by R.V. Kaufman"
  Center 24, "Press any key to continue."
  COLOR 9, 0
  symbolnum = 2
  symbol$ = "    " + CHR$(symbolnum)
  a$ = CHR$(symbolnum)
  FOR I = 1 TO 17
    a$ = a$ + symbol$
  NEXT I
  WHILE INKEY$ <> "": WEND 'Clear keyboard buffer
  WHILE INKEY$ = ""
    FOR a = 1 TO 5
      LOCATE 1, 1                             'print horizontal sparkles
      PRINT MID$(a$, a, 80);
      LOCATE 22, 1
      PRINT MID$(a$, 6 - a, 80);
      FOR B = 2 TO 21                         'Print Vertical sparkles
        c = (a + B) MOD 5
        IF c = 1 THEN
          LOCATE B, 80
          PRINT CHR$(symbolnum);
          LOCATE 23 - B, 1
          PRINT CHR$(symbolnum);
        ELSE
          LOCATE B, 80
          PRINT " ";
          LOCATE 23 - B, 1
          PRINT " ";
        END IF
      NEXT B
    NEXT a
  WEND
  COLOR 10, 0
END SUB

